#include <iostream>
//#include <iomanip>
#include <cmath>
//#include <algorithm>
//#include <string>
//#include <vector>
//#include <ctime>
//#include <cstdlib>
//#include <mycpp.h>

using namespace std;

int takmicar()
{
	int n,m;
	cin>>n>>m;
	unsigned long long A[n];
	unsigned long long B[m];
	for(int i=0;i<n;i++)
		cin>>A[i];
	for(int i=0;i<m;i++)
		cin>>B[i];
	unsigned long long Ar[n-1];
	unsigned long long min;
	for(int i=0;i<n-1;i++)
	{
		Ar[i]=abs(A[i]-A[i+1]);
		if(i==0)
		{
			min=Ar[i];
			continue;
		}
		if(Ar[i]<min)
			min=Ar[i];
	}
	for(int i=2;i<=min;i++)
	{
		bool sviDeljivi=true;
		for(int j=0;j<n-1;j++)
		{
			if(Ar[j]%i!=0)
			{
				sviDeljivi=false;
				break;
			}
		}
		if(sviDeljivi)
		{
			for(int j=0;j<m;j++)
			{
				unsigned long long R=abs(A[0]-B[j]);
				if(R % i == 0)
				{
					return 0;
				}
			}
		}
	}
	return 1;
}

int main()
{
	int t;
	cin>>t;
	int Tacno[t];
	for(int i=0;i<t;i++)
		Tacno[i]=takmicar();
	for(int i=0;i<t;i++)
		cout<<Tacno[i]<<endl;
}